## ros-melodic-khi-robot-control 1.4.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(khi_robot_control)

find_package(catkin REQUIRED
  COMPONENTS
    controller_manager
    diagnostic_updater
    hardware_interface
    joint_limits_interface
    khi_robot_msgs
    realtime_tools
    trajectory_msgs
    transmission_interface)

###################################
## catkin specific configuration ##
###################################
catkin_package(
  CATKIN_DEPENDS
    diagnostic_updater
    khi_robot_msgs
    trajectory_msgs)

###########
## Build ##
###########

include_directories(
  include
  ${catkin_INCLUDE_DIRS}
)

## KRNX
message(STATUS "CMAKE_SYSTEM_NAME : ${CMAKE_SYSTEM_NAME}")
message(STATUS "CMAKE_SYSTEM_PROCESSOR : ${CMAKE_SYSTEM_PROCESSOR}")
message(STATUS "CMAKE_HOST_SYSTEM_NAME : ${CMAKE_HOST_SYSTEM_NAME}")
message(STATUS "CMAKE_HOST_SYSTEM_PROCESSOR : ${CMAKE_HOST_SYSTEM_PROCESSOR}")
message(STATUS "CMAKE_LIBRARY_ARCHITECTURE : ${CMAKE_LIBRARY_ARCHITECTURE}")
if( ${CMAKE_LIBRARY_ARCHITECTURE} MATCHES ".*x86_64.*" )
  set(krnx_lib_name krnx-x86_64)
elseif( ${CMAKE_LIBRARY_ARCHITECTURE} MATCHES ".*aarch64.*" )
  set(krnx_lib_name krnx-aarch64)
elseif( ${CMAKE_LIBRARY_ARCHITECTURE} MATCHES ".*i386.*" )
  set(krnx_lib_name krnx-i386)
elseif( ${CMAKE_LIBRARY_ARCHITECTURE} MATCHES ".*arm.*gnueabihf" )
  set(krnx_lib_name krnx-armhf)
elseif( ${CMAKE_LIBRARY_ARCHITECTURE} MATCHES ".*arm.*gnueabi" )
  set(krnx_lib_name krnx-armel)
else()
  message(WARNING "\nCould not detect system processor architecture: assuming 'x86_64'. This may result in non-working binaries.")
  set(krnx_lib_name krnx-x86_64)
endif()

find_library(krnx_LIBRARIES lib${krnx_lib_name}.so PATHS ${PROJECT_SOURCE_DIR}/lib)
message(STATUS "Found KRNX library at: ${krnx_LIBRARIES}")

## Specify C++11
add_definitions(-std=c++11)

## Declare a C++ library
add_library(khi_robot_client src/khi_robot_client.cpp src/khi_robot_krnx_driver.cpp)

## Declare a C++ executable for ROS_CONTROL
add_executable(main src/main.cpp src/khi_robot_hardware_interface.cpp)

## Specify that we depend on msgs package
add_dependencies(khi_robot_client ${catkin_EXPORTED_TARGETS})

## Specify libraries to link a library or executable target against
target_link_libraries(khi_robot_client ${catkin_LIBRARIES} ${krnx_LIBRARIES})
target_link_libraries(main ${catkin_LIBRARIES} khi_robot_client)

if (CATKIN_ENABLE_TESTING)
  find_package(rostest REQUIRED)
  add_rostest(tests/test_main.xml)
endif()

install(DIRECTORY launch
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})

install(FILES ${krnx_LIBRARIES}
  DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION})

install(TARGETS main khi_robot_client
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})

=== debian/changelog ===
ros-melodic-khi-robot-control (1.4.0-2bionic) bionic; urgency=high

  * Merge pull request #72 <https://github.com/Kawasaki-Robotics/khi_robot/issues/72> from matsui-hiro/rs025n_realrobot
    Add rs025n for real robot
  * update libkrnx(2.3.5)
  * Merge pull request #70 <https://github.com/Kawasaki-Robotics/khi_robot/issues/70> from Yuki-cpp/fix-potential-race-condition
    Create the ControllerManager after robot was openned
  * Create the ControllerManager after robot was openned
    In the khi_robot_control node, the ControllerManager (cm) provides
    services that require controller classes to be loaded beforehand.
    This loading occurs when we open the robot.
    By moving the creation of the ControllerManager after we try to open
    the robot, we ensure that no race condition will occur and that the
    controllers will always be loaded when the provided services are called.
  * Merge pull request #65 <https://github.com/Kawasaki-Robotics/khi_robot/issues/65> from 5567655/master
    Bugfix: contLimitCheck ERROR. Fix for Issue #64 <https://github.com/Kawasaki-Robotics/khi_robot/issues/64>
  * Bugfix: contLimitCheck ERROR
    Function that is supposed to return boolean doesn't return anything
  * Contributors: 5567655, Hiroki Matsui, HirokiTakami, Leo Ghafari, matsui-hiro

 -- nakamichi_d <nakamichi_d@khi.co.jp>  Thu, 27 Apr 2023 15:00:00 -0000

ros-melodic-khi-robot-control (1.3.0-2bionic) bionic; urgency=high

  * Add rs013n (#50 <https://github.com/Kawasaki-Robotics/khi_robot/issues/50>)
    * Add rs013n
    * Update rs013n pkgs
    * Update libkrnx
    * Fixed rs013n_bringup.launch to use xacro
    * Update libkrnx to 2.2.0
    * Modify test program for RS series robots
    * Remove kinetic from travis.yml
  * Contributors: Hiroki Matsui

 -- nakamichi_d <nakamichi_d@khi.co.jp>  Mon, 04 Apr 2022 15:00:00 -0000

ros-melodic-khi-robot-control (1.2.0-2bionic) bionic; urgency=high

  * Merge pull request #43 from d-nakamichi/modify_setting_home_process
    Modify setting home process
  * Modify setting home process
  * Merge pull request #38 from d-nakamichi/krnx_mutex_update
    Update KRNX API processing
  * Update KRNX mutex functions
  * Merge pull request #36 from d-nakamichi/refactoring
    Refactoring about khi_robot_control
  * Remove robot_name arg
  * Fix build problem
  * Change args from value to reference
  * Refactoring khi_robot_controllers/JointData/KrnxRobotTable/RobotInfo/rtc to khi_robot_param/KhiRobotData/KhiRobotControllerInfo/KhiRobotKrnxRtcData
  * Print WARN message when krnx_ExecMon() failed by AS
  * Modify switch changing process
  * Simplify activate() timeout process
  * Don't execute deactivete() when deleted
  * Merge pull request #35 from d-nakamichi/read_velocity
    Travis test bugfix
  * robot_control: correct read(..)/write(..) overrides. (#33)
    * robot_control: correct read(..)/write(..) overrides.
    Both time and period are passed as const references. Not by-value.
    * robot_control: mark read(..)/write(..) as override.
  * Read joint velocities in simulation mode
  * Add joint_limits_interface (#31)
    * Add joint_limits_interface
    * Move joint_limits.yaml from moveit_config to description
    * Modify test messages and conditions in test_position_velocity
    * Change duAro's figure length
    * Move tests from khi_robot_control to khi_robot_test
  * Bugfix about getting signal status (#32)
  * Merge pull request #29 from d-nakamichi/holded_state
    Holded state
  * Add HOLDED state
  * Rearrange state transitions
  * Simplify ROS messages
  * Apply AS switch setting for all robots (#23)
    * Apply AS switch setting for all robots
    * fixup! Apply AS switch setting for all robots
  * Contributors: Daisuke NAKAMICHI, G.A. vd. Hoorn, Hiroki Matsui, d-nakamichi

 -- nakamichi_d <nakamichi_d@khi.co.jp>  Tue, 26 Jan 2021 15:00:00 -0000

ros-melodic-khi-robot-control (1.1.2-2bionic) bionic; urgency=high

  * Enable to build release package on i386/arm (#19 <https://github.com/Kawasaki-Robotics/khi_robot/issues/19>)
    * .travis.yml: add test for i386/armhf/arm64
    * install QEMU for running ARM containers
    * display CMAKE_SYSTEM_NAME variables and so on
    * skip build and test for ARM containers
    * using CMAKE_SYSTEM_PROCESSOR does not returns correct target machine on the docker system. To solve this issue, we use CMAKE_LIBRARY_ARCHITECTURE to find current target machine
    * CMAKE_LIBRARY_ARCHTECTURE is gnueabihf/gnueabi
  * Contributors: Kei Okada

 -- nakamichi_d <nakamichi_d@khi.co.jp>  Thu, 06 Jun 2019 15:00:00 -0000

ros-melodic-khi-robot-control (1.1.1-2bionic) bionic; urgency=high

  * Update a document and error messages (#15 <https://github.com/Kawasaki-Robotics/khi_robot/issues/15>)
    * Modify error messages
    * fixup! Modify error messages
    * fixup! Modify error messages
    * fixup! Modify error messages
    * fixup! Modify error messages
  * set HOME position separately (#16 <https://github.com/Kawasaki-Robotics/khi_robot/issues/16>)
  * Split command string in two (#14 <https://github.com/Kawasaki-Robotics/khi_robot/issues/14>)
  * Merge pull request #13 <https://github.com/Kawasaki-Robotics/khi_robot/issues/13> from d-nakamichi/load_rtc_param
    Load a temporary RTC param file
  * fixup! Load temporary RTC param file
  * Merge pull request #12 <https://github.com/Kawasaki-Robotics/khi_robot/issues/12> from d-nakamichi/control_axes_bug_fix
    Limit AS control axes to ROS driver's control axes
  * Load temporary RTC param file
  * Limit AS control axes to ROS driver's control axes
  * Merge pull request #11 <https://github.com/Kawasaki-Robotics/khi_robot/issues/11> from d-nakamichi/buildfarm_fix
    Add test_depend
  * Add test_depend
  * Contributors: Daisuke NAKAMICHI, Hiroki Matsui, nakamichi_d

 -- nakamichi_d <nakamichi_d@khi.co.jp>  Wed, 24 Apr 2019 15:00:00 -0000

ros-melodic-khi-robot-control (1.1.0-2bionic) bionic; urgency=high



=== debian/control ===
Source: ros-melodic-khi-robot-control
Section: misc
Priority: optional
Maintainer: nakamichi_d <nakamichi_d@khi.co.jp>
Build-Depends: debhelper (>= 9.0.0), ros-melodic-catkin, ros-melodic-controller-manager, ros-melodic-diagnostic-updater, ros-melodic-hardware-interface, ros-melodic-joint-limits-interface, ros-melodic-khi-robot-msgs, ros-melodic-realtime-tools, ros-melodic-rostest, ros-melodic-trajectory-msgs, ros-melodic-transmission-interface
Homepage: http://ros.org/wiki/khi_robot
Standards-Version: 3.9.2

Package: ros-melodic-khi-robot-control
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-melodic-controller-manager, ros-melodic-diagnostic-updater, ros-melodic-hardware-interface, ros-melodic-joint-limits-interface, ros-melodic-joint-state-controller, ros-melodic-joint-trajectory-controller, ros-melodic-khi-robot-msgs, ros-melodic-position-controllers, ros-melodic-trajectory-msgs, ros-melodic-transmission-interface
Description: ROS KHI robot controller package based on ros_control

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-khi-robot-control//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install
